try :
        from qgis.PyQt.QtCore import (QRect, QSettings, QSize, Qt)
        from qgis.PyQt.QtGui import (QAction, QApplication, QButtonGroup, QDockWidget, QFileDialog, QFont, QFrame, QGroupBox, QHeaderView,
                                 QHBoxLayout, QIcon, QImage, QKeySequence, QLabel, QLineEdit, QListWidget,
                                 QListWidgetItem, QMainWindow, QMdiArea, QMenu, QMessageBox, QMovie, QPixmap,
                                 QProgressBar, QPushButton, QScrollArea, QSizePolicy, QTabWidget, QTextEdit, QToolBar,
                                 QTreeWidget, QTreeWidgetItem, QWidget                          
                                 )
except :
        from PyQt4.QtCore import (QRect, QSettings, QSize, Qt)
        from PyQt4.QtGui import (QAction, QApplication, QButtonGroup, QDockWidget, QFileDialog, QFont, QFrame, QGroupBox, QHeaderView,
                                 QHBoxLayout, QIcon, QImage, QKeySequence, QLabel, QLineEdit, QListWidget,
                                 QListWidgetItem, QMainWindow, QMdiArea, QMenu, QMessageBox, QMovie, QPixmap,
                                 QProgressBar, QPushButton, QScrollArea, QSizePolicy, QTabWidget, QTextEdit, QToolBar,
                                 QTreeWidget, QTreeWidgetItem, QWidget                          
                                 )
        
from qgis.gui import QgsMessageBar
from math import ceil as ceil 
from os.path import (basename, dirname, exists, splitext)
from doUI import (DialogAbout, DialogContacts, DialogSGBDR, DialogMetadata, DialogOptions, LoadDialogViewer)
from qsphere_tools import (AddLineWidget, countItems, DicoHasKey, FixeLabelsFileDialog, fixeClassObj, GetExtension, getKeyInDicoFromValue, GetLayerCombo,
                           LoadFile, makeGetOptions, makeHelp, MakePropertiesForWindow, MakeWindowIcon, SendMessage, appendNameSpace, getSelConnexion, getThemeIcon
                           )
from qsphere_objmaker import (
        AuthCSWTDialog, LoadFromLayersDialog, LusTREDialog, myMsgBoxDialog,
        MyPushButton, mySubWindow, toolSearchFilesDialog
        )
from ui_catalogue import MakeLine
from cswt_connector import cswtConnection
from ui_editorXML import xmlEditor
from importexport import (CloseLOG, ExportToXML, MakeDateStampXML, SaveQSP, WriteInLOG)
from xml.etree import ElementTree as ET
from cStringIO import StringIO
from webbrowser import open as webbrowseropen
from textwrap import fill as textwrapfill
try : from urllib.parse import (quote, unquote)
except : from urllib import (quote, unquote)


class myMDIWindow(QMainWindow):
        def __init__(self, parent): 
                QMainWindow.__init__(self)

                self.setObjectName("qsphereMainWindow")
                self.setAccessibleName("qsphereMainWindow")            
                self.setWindowIcon(QIcon(getThemeIcon("qspheremainui.png")))
                self.setWindowFlags(Qt.WindowMaximizeButtonHint | Qt.WindowCloseButtonHint | Qt.WindowMinimizeButtonHint)
                self.setStyleSheet("QMdiSubWindow {color: white; background-color: qlineargradient(x1:0, y1:0, x2:0, y2:1, stop: 0 #cccccc, stop: 1 #5D5D5D);}")
                self.resize(QSize(QRect(50,50, 1100, 800).size()).expandedTo(self.minimumSizeHint()))

                self.dicoLabel = {}
                self.extension = "qsp"
                self.counterNew = 0
                self.currentSession = None

                self.mdi = QMdiArea()
                self.mdi.setTabsClosable(True)
                self.mdi.setTabsMovable(True)

                self.parent = parent
                self.MainPlugin = self.parent.MainPlugin
                self._connexionCSWT = None
                self.webNavigator = None
                self.dialogLUSTRE = None
                self.dialogSearchFiles = None
                self.listSessions = []
                self.listMDDFiles = []
                self.dialogSGBDR = None        

                MakePropertiesForWindow(self, parent)
                self.racTitle = "QSphere %s" % self.version
                self.setWindowTitle(self.racTitle)            
                makeGetOptions(self)

                self.listSubWindows = {}
                self.windowsNoMDIChilds = []

                self.status_txt = QLabel(self.mdi)
                self.movie = QMovie(getThemeIcon("sablier.gif"))
                self.status_txt.setMovie(self.movie)
                self.status_txt.setLayout(QHBoxLayout())
                self.status_txt.layout().addWidget(QLabel(''))
                self.status_txt.setVisible(True)

                self.listNameActionsTabEdition = [ "identificationTab", "classificationTab", "locationTab", "temporalityTab", \
                                               "qualityTab", "rights_and_usesTab", "responsibleTab", "metadataTab", "qgisTab"]

                self.listNameActionsTabWebServices = ["authCSWTButton", "closeCSWTButton", "reportingCSWTButton", "recordsCSWTButton", \
                                         "addCSWTButton", "editCSWTButton", "delCSWTButton"]

                self.styleSheetPushButton = "QPushButton::checked {icon-size: 48px, 48px; border-width: 5px; border-radius: 10px; border-color: black; background-color: #9B9B9B;}"
                self.styleSheetPushButton+= "QPushButton {icon-size: 48px, 48px; border-width: 0px; border-radius: 10px; }"

                self.InitDir = dirname(__file__)

                self.setCentralWidget(self.mdi)

                self.tabWidget = QTabWidget(self)
                self.tabWidget.setObjectName("tabWidget")
                self.tabWidget.setTabShape(QTabWidget.Rounded)
                self.tabWidget.setDocumentMode(True)            
                self.tabWidget.setIconSize(QSize(64, 64))

                self.setMenuWidget(self.tabWidget)
                self.menuWidget().setMinimumHeight(120)
                self.menuWidget().setMaximumHeight(120)


                self.tabFile = QWidget(self.tabWidget)
                self.tabFile.setObjectName("tabFile") 
                self.tabFile.setAccessibleName("tabFile")

                self.loadInfos("sessions", self.listSessions)
                self.loadInfos("fileshistory", self.listMDDFiles) 

                self.listActionsTabFile = [
                ("~" , "Sessions", "sessions.png", (10, 0, 280, 40), None, "", True),              
                ("newSession", "New session", "new.png", (100, 5, 32, 32), self.newSession, "", True),       
                ("openSession", "Load a session QSphere", "open.png", (125, 5, 50, 32), "self.buildContextMnuSession(Obj)", "", True),
                ("saveSession", "Save current session", "save.png", (180, 5, 32, 32), self.saveSession, "", False),
                ("saveSessionAs", "Actions for the sessions", "saveactions.png", (215, 5, 50, 32), "self.contextMnuSaveSessionActions(Obj)", "", True),
                ("-", "-", "", (260, 10, 1, 40), None, "", True),
                ("~" , "Files", "files.png", (10, 0, 330, 40), None, "", True), 
                ("newFile", "New sheet", "new.png", (100, 5, 32, 32), self.newMetadataFile, "", True),
                ("openFile", "Load a metadata file", "open.png", (125, 5, 50, 32), "self.buildContextMnuFile(Obj)", "", True),
                ("saveFile", "Save the current sheet QSphere", "save.png", (180, 5,  32, 32), self.saveMetadataFile, "Ctrl+S", False),
                ("saveFileAs", "Actions for the metadata...", "saveactions.png", (215, 5, 50, 32), "self.contextMnuSaveActions(Obj)", "", False),
                ("saveAll", "Save all files", "saveall.png", (280, 5, 32, 32), self.saveAllMetadataFile, "", False),
                ("-", "-", "", (350, 10, 1, 40), None, "", True),
                ("~" , "Close", "files.png", (10, 0, 160, 40), None, "", True),
                ("close", "Close", "qspherequit.png", (100, 5, 32, 32), self.close, "ALT+F4", True)            
                ]
                toolBar = self.makeMenuCentralWidget(self.tabFile, "tabfiles.png", "Resources",  self.listActionsTabFile, True)

                self.tabEdition = QWidget(self.tabWidget)
                self.tabEdition.setObjectName("tabEdition") 
                self.tabEdition.setAccessibleName("tabEdition") 
                self.positionTab = QButtonGroup(self.tabEdition)
                self.positionTab.setExclusive(True)
                self.changeMode = QButtonGroup(self.tabEdition)
                self.changeMode.setExclusive(True)

                self.listActionsTabEdition = [
                ("~" , "Tabs", "sessions.png", (10, 0, 440, 40), None, "", True),        
                ("identificationTab", "Identification data (title, abstract,\ntype, encoding ...)", "identification.png", (100, 5, 32, 32), self.fixeMetaTab, "", True),
                ("classificationTab", "Classification & Keywords", "classification.png", (135, 5, 32, 32), self.fixeMetaTab, "", True),
                ("locationTab", "Geographical location", "location.png", (170, 5, 32, 32), self.fixeMetaTab, "", True),
                ("temporalityTab", "Dates temporal referencing", "temporality.png", (205, 5, 32, 32), self.fixeMetaTab, "", True),
                ("qualityTab", "Quality, Validity and Conformity", "quality.png", (240, 5, 32, 32), self.fixeMetaTab, "", True),
                ("rights_and_usesTab", "Access and uses", "rights_and_uses.png", (275, 5, 32, 32), self.fixeMetaTab, "", True),
                ("responsibleTab", "Responsible party", "responsible.png", (310, 5, 32, 32), self.fixeMetaTab, "", True),
                ("metadataTab", "Metadata", "metadata.png", (345, 5, 32, 32), self.fixeMetaTab, "", True),
                ("qgisTab", "Metadata by QGIS", "qgis.png", (385, 5, 32, 32), self.fixeMetaTab, "", True),
                ("-", "-", "", (585, 10, 1, 40), None, "", True),
                ("~" , "Modes", "sessions.png", (10, 0, 230, 40), None, "", True),
                ("formMode", "Form view", "n_project.png", (100, 5, 32, 32), None, "", True),
                ("xmlMode", "rendering XML", "n_xml.png", (135, 5, 32, 32), None, "", True),
                ("htmlMode", "rendering HTML", "n_html.png", (170, 5, 32, 32), None, "", True),
                ("-", "-", "", (780, 10, 1, 40), None, "", True),
                ("~" , "Actions", "sessions.png", (10, 0, 230, 40), None, "", True),
                ("reloadWindow", "Reload the current metadata file", "reload.png", (100, 5, 32, 32), self.reloadWindow, "F5", True),
                ("cloneWindow", "Clone current window", "windowclone.png", (135, 5, 32, 32), self.cloneCurrentWindow, "", True),
                ("printTab", "Print current page", "print.png", (175, 5, 32, 32), self.printMetaTab, "Ctrl+P", True),
                ("-", "-", "", (910, 10, 1, 40), None, "", True),
                ("~" , "Wizards", "sessions.png", (10, 0, 220, 40), None, "", True),
                ("wizForm", "Call the form wizard Tables ...", "wizform.png", (100, 5, 32, 32), self.openFormWizardMode, "", False),
                ("wizEditorXML", "Edit XML", "wizeditxml.png", (135, 5, 32, 32), self.openXMLEditorWizardMode, "", False),
                ("wizContacts", "Contacts manager ...", "wizcontacts.png", (170, 5, 32, 32), self.openContactsWizardMode, "", False)
                ]
                toolBar = self.makeMenuCentralWidget(self.tabEdition, "tabedit.png", "Edition",  self.listActionsTabEdition, True)

                self.changeMode.buttonClicked[int].connect(self.changeMetadataMode)

                self.tabWebServices = QWidget(self.tabWidget)
                self.tabWebServices.setObjectName("tabWebServices") 
                self.tabWebServices.setAccessibleName("tabWebServices") 

                self.listActionsTabWebServices = [
                ("~" , "Web", "sessions.png", (10, 0, 170, 40), None, "", True),                    
                ("navigatorWeb", "Web navigator ...", "servers.png", (100, 5, 50, 32), "self.buildContextMnuNavigatorWeb(Obj)", "", True),
                ("-", "-", "", (65, 10, 1, 40), None, "", True),
                ("~" , "Lustre", "sessions.png", (10, 0, 170, 40), None, "", True), 
                ("openLustreWizard", "Call the LusTRE wizard ...", "lustre_wizard.png", (100, 5, 32, 32), self.openLustreWizard, "", True),
                ("-", "-", "", (130, 10, 1, 40), None, "", True),
                ("~" , "CSWT", "sessions.png", (10, 0, 420, 40), None, "", True),
                ("authCSWTButton", "Authentification for the CSW-T Server ...", "connect.png", (100, 5, 32, 32), self.authCSWT, "", True),
                ("closeCSWTButton", "Close the CSWT session", "disconnect.png", (140, 5, 32, 32), self.disconnectCSWT, "", False),
                ("reportingCSWTButton", "Get all reporting for CSWT session", "reporting.png", (190, 5, 32, 32), self.getAllReporting, "", False),
                ("recordsCSWTButton", "Get records in CSWT server", "records.png", (230, 5, 32, 32), self.recordsInCSWT, "", False),
                ("addCSWTButton", "Add to the CSW-T Server", "cloudadd.png", (280, 5, 32, 32), self.insertInCSWT, "", False),
                ("editCSWTButton", "Update to the CSW-T Server", "cloudupdate.png", (320, 5, 32, 32), self.updateInCSWT, "", False),
                ("delCSWTButton", "Delete to the CSW-T Server", "clouddel.png", (360, 5, 32, 32), self.deleteInCSWT, "", False)
                ]
                toolBar = self.makeMenuCentralWidget(self.tabWebServices, "tabwebservices.png", "Web and Services",  self.listActionsTabWebServices, True)

                self.tabToolsOptions = QWidget(self.tabWidget)
                self.tabToolsOptions.setObjectName("tabToolsOptions") 
                self.tabToolsOptions.setAccessibleName("tabToolsOptions") 

                self.listActionsTabOptions = [
                ("~" , "Widget", "sessions.png", (10, 0, 160, 40), None, "", True),
                ("modeWindow", "View / Mask widget control for windows", "windowmdiarea_false.png", (100, 5, 32, 32), self.changeViewWindowsButtons, "", True),
                ("-", "-", "", (190, 10, 1, 40), None, "", True),
                ("~" , "Tools", "sessions.png", (10, 0, 240, 40), None, "", True),        
                ("openToolSearchFiles", "Open search files tool", "toolssearchfiles.png", (100, 5, 32, 32), self.openToolSearchFiles, "", True),
                ("openXMLEditor", "Edit XML", "editxml.png", (140, 5, 32, 32), self.openXMLEditor, "", True),                         
                ("openContacts", "Contacts manager ...", "contact.png", (185, 5, 32, 32), self.openContacts, "", True),
                ("-", "-", "", (190, 10, 1, 40), None, "", True),
                ("~" , "Params", "sessions.png", (10, 0, 160, 40), None, "", True),
                ("openOptions", "Call the options GUI ...", "qsphereoptions.png", (100, 5, 32, 32), self.openOptions, "", True),
                ("-", "-", "", (190, 10, 1, 40), None, "", True),
                ("~" , "Help", "sessions.png", (10, 0, 200, 40), None, "", True),
                ("openHelp", "Call the help page", "help.png", (100, 5, 32, 32), self.openHelp,"F1", True),
                ("sendMail", "Send a mail to developers", "mailto.png", (140, 5, 32, 32), self.sendMail,"", True)
                ]
                toolBar = self.makeMenuCentralWidget(self.tabToolsOptions, "tabtoolsparams.png", "Tools and Params",  self.listActionsTabOptions, True)

                
                self.blocProgressBar = QLabel(self)    
                zIcon = QImage(getThemeIcon("backgroundprogressbar.png"))
                self.blocProgressBar.setPixmap(QPixmap.fromImage(zIcon))
                self.blocProgressBar.setVisible(False)

                self.blocProgressBarButton = MyPushButton(self.blocProgressBar)
                self.blocProgressBarButton.initPushButton(40, 40, 20, 85, "blocProgressBarButton", "", "", True, getThemeIcon(""), 40, 40, True)            

                self.blocProgressBarText = QLabel(self.blocProgressBar)
                self.blocProgressBarText.setStyleSheet("QLabel { font-size: 10px; color : black; background-color: rgba(131, 131, 131, 125); border: 2px solid cyan;  border-radius: 4px;  padding: 2px;}")
                self.blocProgressBarText.setGeometry(5, 140, 390, 80)
                self.blocProgressBarText.setAlignment(Qt.AlignCenter)
                self.blocProgressBarText.setText("")

                self.progressBar = QProgressBar(self.blocProgressBar)
                self.progressBar.setProperty("value", 0)
                self.progressBar.setAlignment(Qt.AlignCenter)
                self.progressBar.setTextVisible(True)
                self.progressBar.setObjectName("progressBar")
                self.progressBar.setStyleSheet("QProgressBar {border: 2px solid grey; border-radius: 5px; text-align: center;}"
                                           "QProgressBar::chunk {background-color: #6C96C6; width: 20px;}")
                self.progressBar.setGeometry(70, 100, 260, 15)
                self.progressBar.setValue(0)

                self.myViewSubWindows = QDockWidget(self.mdi)
                self.myViewSubWindows.setAllowedAreas(Qt.LeftDockWidgetArea | Qt.RightDockWidgetArea)
                self.myViewSubWindows.setWindowTitle("%s : " % QApplication.translate("QSphere", "Widget"))
                self.myViewSubWindows.setVisible(False)
                self.myViewSubWindows.setFloating(True)
                self.myViewSubWindows.minimumWidth, self.myViewSubWindows.minimumHeight = 740, 500
                self.myViewSubWindows.setMinimumSize(self.myViewSubWindows.minimumWidth, self.myViewSubWindows.minimumHeight)
                self.myViewSubWindows.setStyleSheet(
                        "QDockWidget {border: 2px solid grey; border-radius: 5px; text-align: center;background-color:#5D5D5D; padding: 4px ; color:rgb(255,255,255);}"
                        "QDockWidget::title {  text-align: center; background: #5D5D5D; padding-left: 5px;}"
                        )

                self.listActionsTabWindows = [
                ("~" , "Widget", "sessions.png", (10, 0, 260, 40), None, "", True),        
                ("windowsCount", "Sub mainwindow's", "windowscounts.png", (100, 5, 32, 32), None, "", True),
                ("childsCount", "Metadata window's children", "windowchilds.png", (170, 5, 32, 32), None, "", True),
                ("-", "-", "", (145, 10, 1, 40), None, "", True),
                ("~" , "Organize", "sessions.png", (10, 0, 240, 40), None, "", True), 
                ("tileWindows", "Tile windows", "windowstile.png", (100, 5, 32, 32), self.tileWindows, "", True),
                ("cascadeWindows", "Cascade windows", "windowscascade.png", (140, 5, 32, 32), self.cascadeWindows, "", True),
                ("batteriesWindows", "Batteries windows", "windowsbatteries.png", (180, 5, 32, 32), self.batteriesWindows, "", True),
                ("-", "-", "", (325, 10, 1, 40), None, "", True),
                ("~" , "Close", "sessions.png", (10, 0, 190, 40), None, "", True), 
                ("closeWindow", "Close active window", "windowclose.png", (100, 5, 32, 32), self.closeCurrentWindow, "", False),
                ("closeAllWindows", "Close all windows", "windowscloseall.png", (135, 5, 32, 32), self.closeAllMySubWindows, "", False)
                ]
                window = QMainWindow()
                self.toolBarWindows = self.makeMenuCentralWidget(window, "tabwindows.png", "Windows",  self.listActionsTabWindows, False)
                self.myViewSubWindows.setWidget(window)

                self.listWindowsButtons = QTreeWidget(self.myViewSubWindows)
                self.listWindowsButtons.header().hide()
                self.listWindowsButtons.setColumnCount(4)
                self.listWindowsButtons.setGeometry(5, 30, 370, 40)
                self.listWindowsButtons.setIconSize(QSize(24, 24))
                self.listWindowsButtons.setRootIsDecorated(False)

                self.listWindowsButtons.header().resizeSection(0, 250)
                for i in range(1, 3): self.listWindowsButtons.header().resizeSection(i, 32)
                self.listWindowsButtons.header().setResizeMode(0, QHeaderView.Stretch)
                self.listWindowsButtons.header().setResizeMode(1, QHeaderView.ResizeToContents)
                self.listWindowsButtons.header().setResizeMode(2, QHeaderView.ResizeToContents)
                self.listWindowsButtons.header().setResizeMode(3, QHeaderView.ResizeToContents)
                self.listWindowsButtons.header().setStretchLastSection(False)
                self.listWindowsButtons.setStyleSheet("* { font-size:14px; background-color:#5D5D5D; padding: 4px ; color:rgb(255,255,255)}"
                                                      "QTreeWidget::item:selected {color: #5D5D5D;background-color: rgb(255,255,255);}"
                                                      "QToolTip { font-size:9pt; color:black; background-color: rgb(255,255,255); padding:2px; border-width:1px; border-style:solid;}")

                self.myViewSubWindows.visibilityChanged.connect(self.changeAspectButtonViewWindowsButtons)
                self.myViewSubWindows.topLevelChanged.connect(self.FixeMyDock)
                self.myViewSubWindows.resizeEvent = self.FixeMyDockSize

                self.barInfo = QgsMessageBar(self.mdi)
                self.barInfo.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Fixed)

                self.listWindowsButtons.itemClicked.connect(self.actionsForSubWindows)
                self.mdi.subWindowActivated.connect(self.fixeIndex)
                self.iface.mapCanvas().layersChanged.connect(self.majOpenFromLayers)
                try : self.iface.mapCanvas().currentLayerChanged.connect(self.majOpenFromLayers)
                except : pass
                self.iface.newProjectCreated.connect(self.majOpenFromLayers)

                self.xnewsession = MyPushButton(self)
                self.xnewsession.initPushButton(0, 0, 0, 0, "xnewsession", "", QApplication.translate("QSphere", "New session"), True, getThemeIcon("new.png"), 0, 0, False)
                self.xnewsession.setShortcut(QKeySequence("Ctrl+Shift+N"))
                self.xnewsession.clicked.connect(self.newSession)

                self.xopensession = MyPushButton(self)
                self.xopensession.initPushButton(0, 0, 0, 0, "xopensession", "", QApplication.translate("QSphere", "Load a session QSphere"), True, getThemeIcon("new.png"), 0, 0, False)
                self.xopensession.setShortcut(QKeySequence("Ctrl+Shift+F"))
                self.xopensession.clicked.connect(self.openSession)

                self.xsavesession = MyPushButton(self)
                self.xsavesession.initPushButton(0, 0, 0, 0, "xsavesession", "", QApplication.translate("QSphere", "Save current session"), True, getThemeIcon("save.png"), 0, 0, False)
                self.xsavesession.setShortcut(QKeySequence("Ctrl+Shift+W"))
                self.xsavesession.clicked.connect(self.saveSession)

                self.xnewfile = MyPushButton(self)
                self.xnewfile.initPushButton(0, 0, 0, 0, "xnewfile", "", QApplication.translate("QSphere", "New sheet"), True, getThemeIcon("new.png"), 0, 0, False)
                self.xnewfile.setShortcut(QKeySequence("Ctrl+N"))
                self.xnewfile.clicked.connect(self.newMetadataFile)

                self.xopenfile = MyPushButton(self)
                self.xopenfile.initPushButton(0, 0, 0, 0, "xopenfile", "", QApplication.translate("QSphere", "Load a metadata file"), True, getThemeIcon("open.png"), 0, 0, False)
                self.xopenfile.setShortcut(QKeySequence("Ctrl+F"))
                self.xopenfile.clicked.connect(self.openMetadataFile)

                self.xopenFromLayers = MyPushButton(self)
                self.xopenFromLayers.initPushButton(0, 0, 0, 0, "xopenFromLayers", "", QApplication.translate("QSphere", "Load metadata file for layers"), True, getThemeIcon("openfromlayers.png"), 0, 0, False)
                self.xopenFromLayers.setShortcut(QKeySequence("Ctrl+L"))
                self.xopenFromLayers.clicked.connect(self.openMetadataFileForLayers)

                self.xopenFromDataBase = MyPushButton(self)
                self.xopenFromDataBase.initPushButton(0, 0, 0, 0, "xopenFromDataBase", "", QApplication.translate("QSphere", "Load metadata file from database"), True, getThemeIcon("openfromdatabase.png"), 0, 0, False)
                self.xopenFromDataBase.setShortcut(QKeySequence("Ctrl+D"))
                self.xopenFromDataBase.clicked.connect(self.openMetadataFromBase)

                self.xsaveInDataBase = MyPushButton(self)
                self.xsaveInDataBase.initPushButton(0, 0, 0, 0, "xsaveInDataBase", "", "%s ..." % QApplication.translate("QSphere","Save in database"), True, getThemeIcon("openfromdatabase.png"), 0, 0, False)
                self.xsaveInDataBase.setShortcut(QKeySequence("Ctrl+Shift+D"))
                self.xsaveInDataBase.clicked.connect(self.saveMetadataInBase)

                self.xsavefile = MyPushButton(self)
                self.xsavefile.initPushButton(0, 0, 0, 0, "xsavefile", "", QApplication.translate("QSphere", "Save the current sheet QSphere"), True, getThemeIcon("save.png"), 0, 0, False)
                self.xsavefile.setShortcut(QKeySequence("Ctrl+S"))
                self.xsavefile.clicked.connect(self.saveMetadataFile)

                self.xsaveallfiles = MyPushButton(self)
                self.xsaveallfiles.initPushButton(0, 0, 0, 0, "xsaveallfiles", "", QApplication.translate("QSphere", "Save all files"), True, getThemeIcon("saveall.png"), 0, 0, False)
                self.xsaveallfiles.setShortcut(QKeySequence("Ctrl+A"))
                self.xsaveallfiles.clicked.connect(self.saveAllMetadataFile)


                self.refreshGroupWindowsButtons()
                self.majOpenFromLayers()
                self.changeStateButtons(None)
                self.translate(False)



        def translate(self, allItems):

            self.dicoLangs = self.parent.dicoLangs
            self.indexLang = self.parent.indexLang
                
            zElt0 = QApplication.translate("QSphere","project").title()
            zElt1 = QApplication.translate("QSphere","metadata")
            zElt2 = QApplication.translate("QSphere","session")
            self.racWindowTitle = "%s :" % (zElt1.title())
            self.NamedFiltres = {"qsp": "%s QSphere (*.qsp)" % (zElt0), "xml" : "eXtensible Markup Language %s (*.xml)" %( zElt1), "qss" : "%s QSphere (*.qss)" % (zElt2)}

            self.myViewSubWindows.setWindowTitle("%s : " % QApplication.translate("QSphere", "Widget"))

            if not allItems : return

            nameTabs = ("Resources", "Edition", "Web and Services", "Windows", "Tools and Params")

            for i in range(self.tabWidget.count()):
                self.tabWidget.setTabText(i, QApplication.translate("QSphere", nameTabs[i]))
            
            listToTranslate = (self.listActionsTabFile, self.listActionsTabEdition, self.listActionsTabWebServices, self.listActionsTabWindows, self.listActionsTabOptions)
            for myList in listToTranslate :
                for item in myList :
                    if item[0] != "-" :
                       if item[0] == "~" :
                          Obj = self.findChild(QLabel, "Label%s_%s" % (item[1], item[2].split(".")[0]))
                          if Obj : Obj.setText("%s :" % QApplication.translate("QSphere", item[1]))
                       else :
                          Obj = self.findChild(MyPushButton, item[0])
                          if Obj :
                                  zText = QApplication.translate("QSphere",item[1])
                                  if item[0] == "newSession" : zText = "%s%s" % (zText, "Ctrl+Shift+N".rjust(60-len(zText)))
                                  if item[0] == "openSession" : zText = "%s%s" % (zText, "Ctrl+Shift+F".rjust(60-len(zText)))
                                  if item[0] == "saveSession" : zText = "%s%s" % (zText, "Ctrl+Shift+W".rjust(60-len(zText)))
                                  if item[0] == "newFile" : zText = "%s%s" % (zText, "Ctrl+N".rjust(60-len(zText)))
                                  if item[0] == "openFile" : zText = "%s%s" % (zText, "Ctrl+F".rjust(60-len(zText)))
                                  if item[0] == "saveFile" : zText = "%s%s" % (zText, "Ctrl+S".rjust(60-len(zText)))
                                  if item[0] == "saveAll" : zText = "%s%s" % (zText, "Ctrl+A".rjust(60-len(zText)))
                                  Obj.setToolTip("%s" % QApplication.translate("QSphere", zText))
                          else :
                             Obj = self.findChild(QLabel, item[0])
                             if Obj :
                                zText = QApplication.translate("QSphere",item[1])
                                Obj.setToolTip(zText)
 

            Obj = self.findChild(MyPushButton, "openSession")    
            if Obj : self.buildContextMnuSession(Obj)

            Obj = self.findChild(MyPushButton, "saveSessionAs")
            if Obj : self.contextMnuSaveSessionActions(Obj)

            Obj = self.findChild(MyPushButton, "openFile")
            if Obj : self.buildContextMnuFile(Obj)

            Obj = self.findChild(MyPushButton, "saveFileAs")
            if Obj : self.contextMnuSaveActions(Obj)

            Obj = self.findChild(MyPushButton, "navigatorWeb")
            if Obj : self.buildContextMnuNavigatorWeb(Obj)

            keys =  list(self.listSubWindows.keys())
            for Id in keys:
                subWindow = self.listSubWindows[Id]
                item = getKeyInDicoFromValue(self.listWindowsButtons, Id)
                item.setToolTip(0, subWindow.windowTitle())
                if subWindow.windowTitle().find("~")!=-1 : item.setText(0, subWindow.windowTitle())
            
            root = self.listWindowsButtons.invisibleRootItem()
            for i in range(root.childCount()):
                Obj = root.child(i)
                Obj.setToolTip(1, QApplication.translate("QSphere","Hide"))
                Obj.setToolTip(2, QApplication.translate("QSphere","Activate and change position with old active window"))
                Obj.setToolTip(3, QApplication.translate("QSphere","Print"))

        def FixeMyDock(self):
                if not self.myViewSubWindows.isFloating() : self.myViewSubWindows.setFloating(True)

        def fixeMDDWindow(self):
            dialog = None     
            if self.mdi.subWindowList(QMdiArea.CreationOrder)!= [] : 
               dialog = self.mdi.activeSubWindow()
               if not dialog : 
                   dialog = self.mdi.subWindowList(QMdiArea.CreationOrder)[0]
                   self.mdi.setActiveSubWindow(dialog)
               if dialog != None :
                  for child in dialog.children():
                      if type(child)==DialogMetadata : return dialog, child
            return dialog, None    

        def sendMail(self):
            body = """%s : %%0A%%0A

            %s : %%0A%%0A
            
            %s : %%0A
            """  % ("Bugs", "QEP (QSphere Enhancement Proposals)", "Comments")
            try : webbrowseropen("mailto:pegasus2167@hotmail.fr?subject=QSphere%%20%s&body=%s" % (self.version, body))
            except : pass

        def openHelp(self): makeHelp(self)
        def openHelpINSPIRE(self):
            try : webbrowseropen("http://cnig.gouv.fr/?page_id=2916")
            except : pass

        def loadNavigator(self, fileName):
                if self.webNavigator == None :
                        self.webNavigator = LoadDialogViewer(self, self.iface, fileName, False, [], self.langueTR, self, None, "navigatorweb.png", False)
                        self.windowsNoMDIChilds.append(self.webNavigator)
                else :
                        self.webNavigator.addNewTab()
                        self.webNavigator.endLoadTheFile(fileName)
                self.webNavigator.show()

        def changeMetadataMode(self):
            dialog, child = self.fixeMDDWindow()
            if child :               
               idbutton = self.changeMode.id(self.changeMode.checkedButton())
               child.doChangeMode(idbutton)
               child.histoIDChangeMode = idbutton


        def reloadWindow(self):
            dialog, child = self.fixeMDDWindow()
            if child :               
                      self.blocProgressBarButton.setIcon(self.sender().icon())
                      self.blocProgressBarText.setText(textwrapfill("%s :\n %s" % (self.sender().toolTip(), child.windowTitle()), 50))
                      self.blocProgressBar.setVisible(True)     
                      child.ReLoadMetadata()
                      self.blocProgressBar.setVisible(False)

        def majOpenFromLayers(self):
            but = self.findChild(MyPushButton, "openFromLayers")
            if but : but.setEnabled(self.iface.mapCanvas().layerCount() > 0)
                
        def fixeIndex(self):
            dialog, child = self.fixeMDDWindow()
            Id = -1 
            for Id, mdiWindow in self.listSubWindows.items():
                if mdiWindow == dialog :
                   break     
            
            if child :
               index = self.synchroIconTab(child, False, -1)
               self.majCountersSubWindows() 
               self.nb_subwindows.setAlignment(Qt.AlignCenter)
               self.nb_window_childs.setText("%s" % (len(child.childswindows)))
               self.nb_window_childs.setAlignment(Qt.AlignCenter)
               self.fixeModeDialog(child.histoIDChangeMode, index)

               if type(self.sender()) == QMdiArea :
                       item = getKeyInDicoFromValue(self.listWindowsButtons, Id)
                       if item != None : self.listWindowsButtons.setCurrentItem(item)

               self.changeStateButtons(child)
               if child.indexLang != self.MainPlugin.indexLang : child.changeLang()
               

        def majCountersSubWindows(self):
            nb = len(self.mdi.subWindowList(QMdiArea.CreationOrder))
            self.nb_subwindows.setText("%s" % nb)

        def changeStateButtons(self, child):
            if self.dialogSGBDR : self.dialogSGBDR.reloadTabWidget()
            
            controlButtonsEnabled = {"saveSession" : 0, "saveFile" : 3, "saveFileAs" : 1, "saveAll" : 1, "reloadWindow" : 3, "wizForm" : 1, "wizEditorXML" :  1,
                                     "wizContacts" : 1, "addCSWTButton" : 2, "editCSWTButton" : 2, "delCSWTButton" : 2,
                                     "tileWindows" : 1, "cascadeWindows" : 1, "batteriesWindows" : 1, "closeWindow" : 1, "closeAllWindows" : 1}
            borne = self.listWindowsButtons.topLevelItemCount()
            for key in controlButtonsEnabled :
                but = self.findChild(MyPushButton, key)         
                if but :
                      if controlButtonsEnabled[key] == 0: but.setEnabled(self.windowTitle() != self.racTitle)  
                      elif controlButtonsEnabled[key] == 1: but.setEnabled(child != None and borne > 0)
                      elif controlButtonsEnabled[key] == 2: but.setEnabled(child != None and borne > 0 and self._connexionCSWT != None)
                      else :
                           if child : but.setEnabled(child.windowTitle() != child.racWindowTitle and child.windowTitle().find("~")== -1)
                           else : but.setEnabled(False)

            self.tabWidget.setTabEnabled(1, (child != None and borne > 0))
                           

        def fixeModeDialog(self, idbutton, indexpostab):
            nameObj = ("formMode", "xmlMode", "htmlMode")[idbutton]
            Obj = self.findChild(MyPushButton, nameObj)
            if Obj : Obj.setChecked(True)
            nameObj = self.listNameActionsTabEdition[indexpostab]
            Obj = self.findChild(MyPushButton, nameObj)
            if Obj : Obj.setChecked(True)
            
                           
        def fixeMetaTab(self):
            if self.mdi.subWindowList(QMdiArea.CreationOrder)!= [] :
               dialog = self.mdi.activeSubWindow()
               index = self.listNameActionsTabEdition.index(self.sender().objectName())
               for child in dialog.children():
                   if type(child)==DialogMetadata :
                          index = self.synchroIconTab(child, True, index)
                          break
                        
        def synchroIconTab(self, child, fixeIndex, index):
             if not fixeIndex : index = child.tabWidget.currentIndex()
             else : child.tabWidget.setCurrentIndex(index)
             myDefPathIcon = getThemeIcon(self.listActionsTabEdition[index+1][2])
             carIcon = QImage(myDefPathIcon)
             child.currentTab.setPixmap(QPixmap.fromImage(carIcon).scaled(48, 48))

             if type(self.sender()) == MyPushButton :
                     try : self.listWindowsButtons.currentItem().setIcon(0, QIcon(myDefPathIcon))
                     except : pass
                     child.currentTab.setToolTip(self.sender().toolTip())
             return index   

        def printMetaTab(self):
            dialog, child = self.fixeMDDWindow()
            if child : child.PrintMetadata()
            

        #========================
        # BLOC ACTIONS FILES MDD
        #========================                
        def initMetadataDialog(self): 
            self.blocProgressBar.setVisible(True)
            self.blocProgressBar.repaint()

            try : icon = self.sender().icon()
            except :
               try : icon = self.sender().currentItem().icon()
               except : icon = QIcon(getThemeIcon("sgbdr/metadatadownload.png"))
            self.blocProgressBarButton.setIcon(icon)
            
            try : self.blocProgressBarText.setText(textwrapfill("%s" % self.sender().toolTip(), 50))
            except :
                try : self.blocProgressBarText.setText(textwrapfill("%s" % self.sender().mainFrame().url().toString(),50))
                except : self.blocProgressBarText.setText("")

            child =  DialogMetadata(self.iface, self.langue, self.languageIndex, self.langs, self.languesDico, \
                            self.langueTR, self.formats, self.listCodecs, self.listTemporalSystem, \
                            self.listTypeRessources, self.listCountries, self.indexCountry, self.listCountriesCode, self.localeFullName, self)
            child.setWindowTitle("%s ~ %s" % (child.windowTitle(), self.counterNew))    
            mdiWindow = mySubWindow(self, child, QIcon(getThemeIcon("openmeta.png")))
            self.mdi.addSubWindow(mdiWindow)
            self.mdi.setActiveSubWindow(mdiWindow)
            self.blocProgressBar.setVisible(False)
            return mdiWindow, child

        def majSuperviseur(self, mdiWindow):
            myToolTip = mdiWindow.windowTitle()
            myName = basename(myToolTip)
            icon = getThemeIcon("openmeta.png")
            Id = "%s" % mdiWindow.winId()
            
            Obj = QTreeWidgetItem()
            Obj.setText(0, myName)
            Obj.setToolTip(0, myToolTip)
            Obj.setIcon(1, QIcon(getThemeIcon("show.png")))
            Obj.setToolTip(1, QApplication.translate("QSphere","Hide"))
            Obj.setIcon(2, QIcon(getThemeIcon("select.png")))
            Obj.setToolTip(2, QApplication.translate("QSphere","Activate and change position with old active window"))
            Obj.setIcon(3, QIcon(getThemeIcon("print.png")))
            Obj.setToolTip(3, QApplication.translate("QSphere","Print"))
            
            Obj.setWhatsThis(0,  Id)

            self.listWindowsButtons.addTopLevelItem(Obj)
            self.listSubWindows[Id] = mdiWindow
            self.listWindowsButtons.setCurrentItem(Obj)
                        
            self.refreshGroupWindowsButtons()
            dialog, child = self.fixeMDDWindow()
            self.changeStateButtons(child)
            icon = child.currentTab.pixmap() 
            Obj.setIcon(0, QIcon(icon))

            

        def newSession(self):
            self.currentSession = None
            self.setWindowTitle(self.racTitle)
            self.butsavesession.setEnabled(self.currentSession != None)
            self.closeAllMySubWindows()

        def openLastSession(self) :
            icon = self.sender().icon()
            text = QApplication.translate("QSphere","Load a session file")
            if self.sender().text()!= "" :
                    textSender = self.sender().text()
                    result = self.loadTheSession(textSender, icon, text)
                    if not result :
                            self.listSessions.remove(textSender)
                            self.ajustListInfos("", self.listSessions)

        def openLastFile(self):
            icon = self.sender().icon()
            text = QApplication.translate("QSphere","Load a session file")
            fileName = self.sender().text()
            if exists(fileName) :
                self.loadMDDFile(fileName, False, -1)     
                self.InitDir = dirname(fileName)
            else :   
                self.listMDDFiles.remove(fileName)
                self.ajustListInfos("", self.listMDDFiles)

        def openSession(self):
            extension = "qss"
            icon = self.sender().icon()
           
            text = QApplication.translate("QSphere","Load a session file")
            MyFileDialog = QFileDialog(self, text)
            MyFileDialog.setNameFilters([items[1] for items in self.NamedFiltres.items() if items[0]==extension]) 
            MyFileDialog.selectNameFilter(self.NamedFiltres[extension])
            MyFileDialog.setDefaultSuffix(extension)
            MyFileDialog.setViewMode(QFileDialog.Detail)
            MyFileDialog.setDirectory(self.InitDir)
            MyFileDialog.setFileMode(QFileDialog.ExistingFile)  
            MyFileDialog.setAcceptMode(QFileDialog.AcceptOpen)

            FixeLabelsFileDialog(self, MyFileDialog, 0, True)
                
            if MyFileDialog.exec_():
               fileName = "%s" % (MyFileDialog.selectedFiles()[0])
               if fileName!="" :
                  result = self.loadTheSession(fileName, icon, text)
                  if result : self.ajustListInfos(fileName, self.listSessions)

        def BadMyISO(self):
                zMsg = QApplication.translate("QSphere","Invalid XML document !")
                if self.showWarning : SendMessage(self, "information" , zMsg, QgsMessageBar.WARNING, self.duration_warning)  

        def loadTheSession(self, fileName, icon, text):       
                try :
                        self.tree = ET.parse(fileName)
                except :
                        self.BadMyISO()
                        return False
                self.counterNew = 0
                child = None
                self.currentSession = fileName
                self.setWindowTitle("%s : %s" % (self.racTitle, fileName))
                self.InitDir = dirname(fileName)

                self.blocProgressBarButton.setIcon(icon)
                self.blocProgressBarText.setText(textwrapfill("%s :\n %s" % (text,fileName), 50))
                self.blocProgressBar.setVisible(True)  

                self.closeAllMySubWindows()
                
                self.root = self.tree.getroot()

                formMainUI = self.root.findall("formMainUI")
                for node in formMainUI:
                  try : 
                          test = eval(node.find("modeWindow").text)
                          self.myViewSubWindows.setVisible(test)                          
                          Obj = self.findChild(MyPushButton, "modeWindow")
                          if Obj : Obj.setIcon(QIcon(getThemeIcon("windowmdiarea_%s.png".lower() % self.myViewSubWindows.isVisible())))
                  except : pass

                subWindows = self.root.findall("subWindow")
                dialogFocused = None
                counterTemp = 0

                for node in subWindows :
                      dicoSubWindow = self.parse_subWindow(node)
                      try : source = QApplication.translate("QSphere", dicoSubWindow["source"])
                      except :
                             self.blocProgressBar.setVisible(False) 
                             self.BadMyISO()
                             return False 
                      mdiWindow, child = self.loadMDDFile(source, False, -1) if source !="" and source else self.newMetadataFile()

                      if not source :
                         dataQSP = dicoSubWindow["projecttemp"]

                         from io import StringIO as bufferData
                         from xmlISOparser import xmlISOparser
                         buffer = bufferData(dataQSP) 
                         myISO = xmlISOparser(None, buffer , 'MEDDE', 'fr') 
                         myISO.createISOdataStructure(True)

                         try :       
                            if myISO.getTagDictionnary() :
                              child.ReloadDataFromXML(myISO, None, 0)
                              child.setWindowTitle("%s ~ %s" % (child.windowTitle(), counterTemp))
                              counterTemp+= 1
                         except :
                            try : result = child.GetDataFromFluxQSP(dataQSP)
                            except : pass
                      
                      if child :
                         posx = dicoSubWindow["posx"] 
                         posy = dicoSubWindow["posy"] 
                         width = dicoSubWindow["width"]
                         height = dicoSubWindow["height"]
                         visible = dicoSubWindow["visible"]       

                         try : mdiWindow.setGeometry(int(posx), int(posy), int(width), int(height))
                         except : pass                           
                         if dicoSubWindow["activate"]=="True" : dialogFocused = mdiWindow

                         try : child.tabWidget.setCurrentIndex(int(dicoSubWindow["tabwidgetcurrentindex"]))
                         except : pass

                         try :
                               child.ComboLayers.setCurrentIndex(int(dicoSubWindow["ComboLayers"]))
                               child.PrimaryXSLT.setCurrentIndex(int(dicoSubWindow["PrimaryXSLT"]))  
                         except : pass
                         
                         try :        
                               idbutton = int(dicoSubWindow["histoIDChangeMode"])
                               child.tabWidget.currentChanged[int].connect(child.fixeTabMainWindow)
                               child.fixeTabMainWindow(child.tabWidget.currentIndex())
                               child.doChangeMode(idbutton)
                               child.histoIDChangeMode = idbutton
                               
                               icon = child.currentTab.pixmap()
                               self.listWindowsButtons.currentItem().setIcon(0, QIcon(icon))

                               if dicoSubWindow["visible"]=="False" :
                                  mdiWindow.setVisible(False)
                                  icon = getThemeIcon("hide.png")
                                  toolTip = QApplication.translate("QSphere","View")
                               else :
                                  mdiWindow.setVisible(True)
                                  icon = getThemeIcon("show.png")
                                  toolTip = QApplication.translate("QSphere","Hide")
                               self.listWindowsButtons.currentItem().setIcon(1, QIcon(icon))
                               self.listWindowsButtons.currentItem().setToolTip(1, toolTip)
                               
                         except : pass
                         
                if dialogFocused :       
                  self.mdi.setActiveSubWindow(dialogFocused)      
                  dialogFocused.setFocus()
                self.butsavesession.setEnabled(self.currentSession != None)
                self.blocProgressBar.setVisible(False)
                self.fixeIndex()

                return True
                  
        def parse_subWindow(self, node):
            dicoSubWindow = {}
            keys = ("title", "source", "posx", "posy", "width", "height", "ComboLayers", "PrimaryXSLT", "activate", "visible", "projecttemp", "tabwidgetcurrentindex", "histoIDChangeMode")
            for key in keys :
                try : dicoSubWindow[key] = node.find(key).text
                except :
                       if key in ("title", "source", "activate", "projecttemp") : dicoSubWindow[key] = ""
                       elif key in ("posx", "posy", "width", "height", "ComboLayers", "PrimaryXSLT", "tabwidgetcurrentindex", "histoIDChangeMode"): dicoSubWindow[key] = 0
                       elif key == "activate" : dicoSubWindow[key] = "False" 
                       elif key == "visible" : dicoSubWindow[key] = "True" 
            return dicoSubWindow

               
        def saveSession(self) :
            extension = "qss"
            if self.sender() == self.SaveSessionAsButton : zTitle = QApplication.translate("QSphere","Save session as file")
            elif self.sender() == self.SaveSessionCopyAsButton : zTitle = QApplication.translate("QSphere","Save session as copy file")
            else : zTitle = QApplication.translate("QSphere","Save session file")        

            fileName = ""        
            if self.sender() in (self.SaveSessionAsButton, self.SaveSessionCopyAsButton) or self.currentSession == None :
                    MyFileDialog = QFileDialog(self, zTitle)
                    MyFileDialog.setNameFilters([items[1] for items in self.NamedFiltres.items() if items[0]==extension]) 
                    MyFileDialog.selectNameFilter(self.NamedFiltres[extension])
                    MyFileDialog.setDefaultSuffix(extension)
                    MyFileDialog.setViewMode(QFileDialog.Detail)
                    MyFileDialog.setDirectory(self.InitDir)
                    MyFileDialog.setAcceptMode(QFileDialog.AcceptSave)

                    FixeLabelsFileDialog(self, MyFileDialog, 1, True)
                        
                    if MyFileDialog.exec_():
                       fileName = "%s" % (MyFileDialog.selectedFiles()[0])
            else :
                    fileName = self.currentSession    
                                      
            if fileName!="" :
               self.doSaveSession(fileName)
               
               if self.sender() != self.SaveSessionCopyAsButton :
                  self.ajustListInfos(fileName, self.listSessions)
                  self.InitDir = dirname(fileName)
                  self.currentSession = fileName
                  self.setWindowTitle("%s : %s" % (self.racTitle, fileName))

               zTitle = QApplication.translate("QSphere", "Information" ) 
               zMsg = QApplication.translate("QSphere","The session's file was saved as")
               SendMessage(self, zTitle , "%s :<br><u><i>%s</i></ul>" % (zMsg, fileName), QgsMessageBar.INFO, self.duration_info)


        def doSaveSession(self, fileName):                
            zLOG = open(fileName, "w", encoding="utf-8", errors="surrogateescape")
            WriteInLOG(zLOG, '<?xml version="1.0" encoding="UTF-8"?>\n')
            WriteInLOG(zLOG, '<gmd:MD_Metadata xsi:schemaLocation="http://www.isotc211.org/2005/gmd http://schemas.opengis.net/iso/19139/20060504/gmd/gmd.xsd" xmlns:gmd="http://www.isotc211.org/2005/gmd" xmlns:gco="http://www.isotc211.org/2005/gco" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:gml="http://www.opengis.net/gml" xmlns:xlink="http://www.w3.org/1999/xlink">\n')
            WriteInLOG(zLOG, '\t<gmd:qspheresession>\n')
            WriteInLOG(zLOG, '\t\t<gco:file>\n')
            WriteInLOG(zLOG, '\t\t\t<gco:CharacterString>%s</gco:CharacterString>\n' % (fileName))
            WriteInLOG(zLOG, '\t\t</gco:file>\n')
            WriteInLOG(zLOG, '\t\t<gmd:language>\n')
            WriteInLOG(zLOG, '\t\t\t<gmd:LanguageCode codeList="http://www.loc.gov/standards/iso639-1/" codeListValue="%s">%s</gmd:LanguageCode>\n' % (self.langueTR, self.langueTR))
            WriteInLOG(zLOG, '\t\t</gmd:language>\n')
            MakeDateStampXML(self, 1, False,  None)
            WriteInLOG(zLOG, '\t</gmd:qspheresession>\n')
            
            WriteInLOG(zLOG, '\t<formMainUI name="%s">\n' % (self.objectName()))
            WriteInLOG(zLOG, '\t\t<postab>%s</postab>\n' % self.tabWidget.currentIndex())
            WriteInLOG(zLOG, '\t\t<modeWindow>%s</modeWindow>\n' % (self.myViewSubWindows.isVisible()))
            WriteInLOG(zLOG, '\t</formMainUI>\n')
            
            counter=0

            for subWindow in self.mdi.subWindowList(QMdiArea.CreationOrder):
                WriteInLOG(zLOG, '\t<subWindow>\n')
                WriteInLOG(zLOG, '\t\t<id>%s</id>\n' % counter)           
                for child in subWindow.children():
                      if type(child)==DialogMetadata :
                         fileName = ""     
                         if child.windowTitle() != child.racWindowTitle and child.windowTitle().find("~")== -1 : fileName = child.windowTitle().replace(child.racWindowTitle, "")
                         WriteInLOG(zLOG, '\t\t<source>%s</source>\n' % QApplication.translate("QSphere", fileName.encode("utf-8"))) 
                         if fileName == "" :
                            WriteInLOG(zLOG, '\t\t<projecttemp><![CDATA[%s]]></projecttemp>\n' % ExportToXML(child, None))      
                         else : WriteInLOG(zLOG, '\t\t<projecttemp></projecttemp>\n')
                         WriteInLOG(zLOG, '\t\t<tabwidgetcurrentindex>%s</tabwidgetcurrentindex>\n' % child.tabWidget.currentIndex())
                         WriteInLOG(zLOG, '\t\t<histoIDChangeMode>%s</histoIDChangeMode>\n' % child.histoIDChangeMode)
                         WriteInLOG(zLOG, '\t\t<ComboLayers>%s</ComboLayers>\n' % child.ComboLayers.currentIndex())
                         WriteInLOG(zLOG, '\t\t<PrimaryXSLT>%s</PrimaryXSLT>\n' % child.PrimaryXSLT.currentIndex())
                         break     
                WriteInLOG(zLOG, '\t\t<posx>%s</posx>\n' % subWindow.x())
                WriteInLOG(zLOG, '\t\t<posy>%s</posy>\n' % subWindow.y())
                WriteInLOG(zLOG, '\t\t<width>%s</width>\n' % subWindow.width())
                WriteInLOG(zLOG, '\t\t<height>%s</height>\n' % subWindow.height())
                WriteInLOG(zLOG, '\t\t<activate>%s</activate>\n' % (subWindow == self.mdi.activeSubWindow()))    
                WriteInLOG(zLOG, '\t\t<visible>%s</visible>\n' % subWindow.isVisible())
                WriteInLOG(zLOG, '\t</subWindow>\n')
                counter+= 1
                
            WriteInLOG(zLOG, "</gmd:MD_Metadata>\n" )
            CloseLOG(zLOG)

    
        def newMetadataFile(self):
            mdiWindow, child = self.initMetadataDialog()
            child.show()
            self.counterNew+= 1
            self.majSuperviseur(mdiWindow)
            self.tabWidget.setCurrentIndex(1)
            return mdiWindow, child

        def openMetadataFileForLayers(self): 
            dialog = LoadFromLayersDialog(self.iface, self)
            MakeWindowIcon(dialog, "layers-icon.png")
            if dialog.exec_():
               for elt in dialog.qgisLayersList():
                   infos = elt.split("|")    
                   fileName = infos[0]
                   layerid  = infos[1]
                   if fileName!="" :
                      self.loadMDDFile(fileName, True, layerid)     
                      self.InitDir = dirname(fileName)

        def saveMetadataInBase(self):
            if self.listSubWindows != {} :
               if self.dialogSGBDR == None : self.dialogSGBDR = DialogSGBDR(self.iface, self, 0, QApplication.translate("QSphere", "Save"))
               self.dialogSGBDR.show()
            
        def openMetadataFromBase(self):              
            if self.dialogSGBDR == None : self.dialogSGBDR = DialogSGBDR(self.iface, self, 1, QApplication.translate("QSphere", "Load a metadata file"))
            self.dialogSGBDR.show()

        def openMetadataFile(self):
                extension = self.extension 
                zTitle = QApplication.translate("QSphere","Load a metadata file")
                MyFileDialog = QFileDialog(self, zTitle)
                MyFileDialog.setNameFilters([items[1] for items in self.NamedFiltres.items() if items[0]!="qss"])  
                MyFileDialog.selectNameFilter(self.NamedFiltres[extension])
                MyFileDialog.setDefaultSuffix(extension)
                MyFileDialog.setViewMode(QFileDialog.Detail)
                MyFileDialog.setDirectory(self.InitDir)
                MyFileDialog.setFileMode(QFileDialog.ExistingFiles)  
                MyFileDialog.setAcceptMode(QFileDialog.AcceptOpen)

                FixeLabelsFileDialog(self, MyFileDialog, 0, True)
                
                if MyFileDialog.exec_():
                    if  MyFileDialog.selectedFiles() != [] :   
                        for fileName in MyFileDialog.selectedFiles() :
                            if fileName!="" :
                               self.loadMDDFile(fileName, False, -1)
                               self.InitDir = dirname(fileName)
                               self.ajustListInfos(fileName, self.listMDDFiles)

        def loadMDDFile(self, fileName, fromLayer, layerid):
                mdiWindow, child = self.initMetadataDialog()
                self.fixeModeDialog(0, 0)
                extension = GetExtension(fileName)
                self.extension = extension.replace(".","")
                try : icon = self.sender().icon()
                except :
                     try : icon = self.sender().currentItem().icon()
                     except : icon = QIcon(getThemeIcon("unknow.png"))
                self.blocProgressBarButton.setIcon(icon)
                if self.sender().toolTip() != fileName : self.blocProgressBarText.setText(textwrapfill("%s :\n %s" % (self.sender().toolTip(), fileName), 50))
                else : self.blocProgressBarText.setText(textwrapfill("%s" % fileName, 50))
                self.blocProgressBar.setVisible(True)
      
                if extension == "" and fileName.startswith("pgmdd:"): child.GetDataFromPGMDD(fileName)
                else :
                        if extension == ".qsp" : child.GetDataFromQSP(fileName)
                        elif extension == ".xml" : child.GetDataFromXML(fileName)
                        elif extension == ".xqsp" : child.GetDataFomXQSP(fileName)

                if fromLayer :
                   IndexLayer = GetLayerCombo(child, child.ComboLayers, layerid)
                   child.ComboLayers.setCurrentIndex(IndexLayer)
                   
                   if child.ComboLayers.currentIndex() > 0 : 
                      child.IsVisibleRestoreDico(True)
                      child.GetMetaData()
                      if child.autoComment and extension == ".qsp" : child.RestoreComments()
                      child.IsVisibleRestoreDico(extension == ".qsp")
                
                self.blocProgressBar.setVisible(False)
                child.show()
                self.majSuperviseur(mdiWindow)
                self.tabWidget.setCurrentIndex(1)
                return mdiWindow, child

        def DownloadMetadata(self):
                zicon, zurl = "navigatorweb.png", "#blank"
                if self.sender().objectName() == "openHelp" :
                    zLang = "_%s" % (self.langueTR) if self.langueTR!= "en" else ""
                    zicon, zurl = "help.png", getThemeIcon("ressources/html/help/index%s.html" % (zLang))
                else :
                    zurl = self.sender().text() if self.sender().objectName()!= "mActionNavigator" else ""
                self.loadNavigator(zurl)

        def makeMajGetOptions(self):
            listSubWindows = self.mdi.subWindowList(QMdiArea.CreationOrder)    
            if listSubWindows!= [] :
               for subWindow in listSubWindows :     
                       for child in subWindow.children():
                           if type(child)==DialogMetadata : makeGetOptions(child); break;

        def saveAllMetadataFile(self):
            listSubWindows = self.mdi.subWindowList(QMdiArea.CreationOrder)    
            if listSubWindows!= [] :
               for subWindow in listSubWindows :     
                       for child in subWindow.children():
                           if type(child)==DialogMetadata :
                                  if child.windowTitle() != child.racWindowTitle and child.windowTitle().find("~")== -1 :                
                                          child.SaveData()
                                          break
                                
        def saveMetadataFile(self):
            dialog, child = self.fixeMDDWindow()
            if child : child.SaveData()
                          
               
        def saveAsMetadataFile(self):
            index = 2 if self.sender().objectName() == "SaveCopyAsButton" else 1
            dialog, child = self.fixeMDDWindow()
            if child :
               child.InitDir = self.InitDir  
               child.SaveDataAs(index)
            

        def saveXmlCatFile(self):
            dialog, child = self.fixeMDDWindow()
            if child : child.SaveXmlCat()

        #===============================
        # BLOC ACTIONS EDITION - WIZARDS
        #===============================
        def openFormWizardMode(self):
            dialog, child = self.fixeMDDWindow()
            if child : child.OpenFormTable(child.focusWidget())
                      
        def openXMLEditorWizardMode(self):
            dialog, child = self.fixeMDDWindow()
            if child :
                if child.windowTitle().startswith("%spgmdd:" % child.racWindowTitle) or child.windowTitle() == child.racWindowTitle or child.windowTitle().find("~")!= -1:
                     dataXML = ExportToXML(child, None)
                     d = xmlEditor(child, "")
                     MakeWindowIcon(d, "editxml.png")
                     d.setWindowTitle("%s : %s" % (d.racTitle, child.windowTitle()))
                     d.editor.setText(dataXML) 
                     d.checkProperties()
                     d.BadMyISO()
                     d.exec_()                   
                else :        
                        if child.windowTitle() != child.racWindowTitle and child.windowTitle().find("~")== -1 :
                            fileName = child.windowTitle().replace(child.racWindowTitle, "")
                            textension = splitext(fileName)
                            extension = textension[len(textension)-1].lower()
                            if extension == ".xml" :
                               d = xmlEditor(child, fileName)
                               MakeWindowIcon(d, "wizeditxml.png")
                               d.setWindowTitle("%s : %s" % (d.racTitle, fileName))
                               d.LoadFile()
                               d.exec_()
                            else :
                               dataXML = ExportToXML(child, None)
                               self.getReporting(dataXML.decode("utf-8"), False, "wizeditxml.png", True)


        def openContactsWizardMode(self):
            dialog, child = self.fixeMDDWindow()
            if child :
               orIndex = child.tabWidget.currentIndex()
               child.tabWidget.setCurrentIndex(6)
               nameObj = self.listNameActionsTabEdition[6]
               Obj = self.findChild(MyPushButton, nameObj)
               if Obj : Obj.setChecked(True)                           
               d = DialogContacts(child, True)
               d.exec_()
               child.tabWidget.setCurrentIndex(orIndex)

        #========================
        # BLOC ACTIONS WINDOWS
        #========================             
        def tileWindows(self):
            dialog, child = self.fixeMDDWindow()    
            self.mdi.tileSubWindows()    
            self.mdi.setActiveSubWindow(dialog)
            dialog.setFocus()
            
        def cascadeWindows(self):
            dialog, child = self.fixeMDDWindow()        
            self.mdi.cascadeSubWindows()
            self.mdi.setActiveSubWindow(dialog)
            dialog.setFocus()

        def batteriesWindows(self):
            subWindows = self.mdi.subWindowList(QMdiArea.CreationOrder)
            N = len(subWindows)
            if N == 0 : return    

            from math import pi, sin ,cos, sqrt    
            self.cascadeWindows()
            dialog, child = self.fixeMDDWindow()

            centerX = subWindows[0].width()
            dialog.setGeometry(0, 0, dialog.width(), dialog.height())
            elt = 0
            for itheta in range(N):
                if subWindows[itheta]!=dialog :
                   subWindows[itheta].setGeometry(centerX, 100*elt, subWindows[itheta].width(), subWindows[itheta].height())
                   elt+= 1
                
            self.mdi.setActiveSubWindow(dialog)
            dialog.setFocus()
            self.mdi.horizontalScrollBar().setValue(0)
            self.mdi.verticalScrollBar().setValue(0)
                

        def closeAllMySubWindows(self):
                self.counterNew = 0
                keys =  list(self.listSubWindows.keys())
                for Id in keys:
                        self.mdi.removeSubWindow(self.listSubWindows[Id])
                        item = getKeyInDicoFromValue(self.listWindowsButtons, Id)        
                        index = self.listWindowsButtons.indexOfTopLevelItem(item)
                        if index > -1 : self.listWindowsButtons.takeTopLevelItem(index)
                        del self.listSubWindows[Id]
                self.majCountersSubWindows()
                self.listSubWindows = {}
                self.listWindowsButtons.clear()
                self.refreshGroupWindowsButtons()
                self.changeStateButtons(None)

        def FixeMyDockSize(self, obj): self.refreshGroupWindowsButtons()
                
                
        def refreshGroupWindowsButtons(self):
            borne = self.listWindowsButtons.topLevelItemCount()
            self.myViewSubWindows.minimumHeight = (60 + 30*(borne-1)) if borne > 0 else 80
            self.toolBarWindows.setGeometry(5, 5, self.myViewSubWindows.width()-10, 50)
            self.myViewSubWindows.setMinimumSize(self.myViewSubWindows.minimumWidth, self.myViewSubWindows.minimumHeight+40)
            self.listWindowsButtons.setGeometry(self.listWindowsButtons.x(), 60, self.myViewSubWindows.width()-10, self.myViewSubWindows.minimumHeight-20)


        def actionsForSubWindows(self, item, column):
            self.listWindowsButtons.setEnabled(False)    
            oldActiveSubWindow = self.mdi.currentSubWindow()
                           
            if DicoHasKey(self.listSubWindows, item.whatsThis(0)):        
                    activeSubWindow = self.listSubWindows[item.whatsThis(0)]
                    if column in (0, 2, 3) :
                            if column == 2 :
                                    newposition = (oldActiveSubWindow.x(), oldActiveSubWindow.y(), oldActiveSubWindow.width(), oldActiveSubWindow.height())
                                    oldposition = (activeSubWindow.x(), activeSubWindow.y(), activeSubWindow.width(), activeSubWindow.height())
                                    activeSubWindow.setGeometry(newposition[0], newposition[1], newposition[2], newposition[3]) 
                                    oldActiveSubWindow.setGeometry(oldposition[0], oldposition[1], oldposition[2], oldposition[3])        
                            if column in (2, 3) : self.tabWidget.setCurrentIndex(1)
                            if column == 3 :
                               self.mdi.setActiveSubWindow(activeSubWindow)
                               self.printMetaTab()
                            
                    elif column == 1 :
                            activeSubWindow.setVisible(not activeSubWindow.isVisible())
                            
                            if activeSubWindow.isVisible() == False : icon, textToolTip = "hide.png", "View"
                            else : icon, textToolTip = "show.png", "Hide"
                            
                            item.setIcon(1, QIcon(getThemeIcon(icon)))
                            item.setToolTip(1, QApplication.translate("QSphere", textToolTip))
                            
                    if column < 3 : self.mdi.setActiveSubWindow(activeSubWindow)
                    else : self.mdi.setActiveSubWindow(oldActiveSubWindow)                      
            self.listWindowsButtons.setEnabled(True)
           
        def cloneCurrentWindow(self):
            refdialog, refchild = self.fixeMDDWindow()
            idbutton = self.changeMode.id(self.changeMode.checkedButton())
            dialog, child = self.newMetadataFile()
            

            MakePropertiesForWindow(child, refchild)
            child.ParamsLineWidget = refchild.ParamsLineWidget
            child.show()

            zTabs = refchild.tabWidget.count()
            posIndex = refchild.tabWidget.currentIndex()
            zObj = None
            for i in range(zTabs):
                refchild.tabWidget.setCurrentIndex(i)
                zTab = refchild.tabWidget.currentWidget()
                zObjs = zTab.children()

                for j in range(len(zObjs)):
                    zNameObj = "%s" % (zObjs[j].accessibleName())
                    zClassObjName = "%s" % (zObjs[j].metaObject().className())
                    
                    if not zClassObjName in ("QCommandLinkButton", "MyPushButton", "QLabel") and zNameObj != "" :
                       zCopyTableWidget = fixeClassObj(zClassObjName, zNameObj, child) 
                       TableWidget = zObjs[j]

                       if zCopyTableWidget == None : pass
                       else : 
                               if zClassObjName in ("QTableWidget", "MyTableWidget") and zNameObj != "tablemotsclefso" :
                                  for zRow in range(TableWidget.rowCount()):
                                     if zRow > zCopyTableWidget.rowCount()-1 : MakeLine(child, zCopyTableWidget, True, False, zRow, False)
                                     for zCol in range(TableWidget.columnCount()):
                                           OriginalWidget = TableWidget.cellWidget(zRow, zCol) if TableWidget.cellWidget(zRow, zCol)!= None else TableWidget.item(zRow, zCol)
                                           TargetObjWidget = zCopyTableWidget.cellWidget(zRow, zCol) if zCopyTableWidget.cellWidget(zRow, zCol)!= None else zCopyTableWidget.item(zRow, zCol)  
                                           try :  
                                                   if OriginalWidget.metaObject().className() in ("QLineEdit", "MySimpleWidgetLineEdit", "MyWidgetLineEdit", "MySimpleWidgetLineEditST") : TargetObjWidget.setText(OriginalWidget.text())
                                                   elif OriginalWidget.metaObject().className() in ("QCheckBox", "MyCheckBox") : TargetObjWidget.setChecked(OriginalWidget.isChecked())
                                                   elif OriginalWidget.metaObject().className() == "MyComboBox" :
                                                       TargetObjWidget.setCurrentIndex(OriginalWidget.currentIndex())
                                                       TargetObjWidget.setEnabled(OriginalWidget.isEnabled())
                                                   elif OriginalWidget.metaObject().className() == "MySpinBox" : TargetObjWidget.setValue(OriginalWidget.value())
                                           except :
                                                   try : TargetObjWidget.setText(OriginalWidget.text())
                                                   except : pass
                                                   
                                  countItems(dialog, zNameObj, zCopyTableWidget)
                                     
                               elif zClassObjName == "QTableView" :
                                   for zRow in range(TableWidget.model().rowCount()):
                                       for zCol in range(TableWidget.model().columnCount()):
                                           zItem = TableWidget.model().item(zRow, 0)
                                           zCopyTableWidget.model().item(zRow, 0).setCheckState(zItem.checkState())

                               elif zClassObjName == "QCalendarWidget" : zCopyTableWidget.setSelectedDate(TableWidget.selectedDate())
                               elif zClassObjName in ("QTextEdit", "MyTextEdit") :  zCopyTableWidget.setPlainText(TableWidget.toPlainText()) 
                               elif zClassObjName in ("QLineEdit", "MySimpleWidgetLineEdit", "MyWidgetLineEdit") : zCopyTableWidget.setText(TableWidget.text()) 
                               elif zClassObjName in ("QComboBox", "MyComboBox") : zCopyTableWidget.setCurrentIndex(TableWidget.currentIndex())
                               elif zClassObjName == "QRadioButton" : zCopyTableWidget.setChecked(TableWidget.isChecked())
                               elif zClassObjName == "QGroupBox" :

                                    for ic in range(len(TableWidget.children())) :
                                        childGroup = TableWidget.children()[ic]
                                        childClone = zCopyTableWidget.children()[ic]
                                        
                                        if childGroup.metaObject().className()== "QTableView" :
                                           for zRowc in range(childGroup.model().rowCount()):
                                               for zColc in range(childGroup.model().columnCount()):
                                                   zItem = childGroup.model().item(zRowc, 0)
                                                   childClone.model().item(zRowc, 0).setCheckState(zItem.checkState())
                                        elif childGroup.metaObject().className() == "QRadioButton" : childClone.setChecked(childGroup.isChecked())           
                                        elif childGroup.metaObject().className() in ("QTableWidget", "MyTableWidget") :
                                               childClone.clearContents()
                                               for jc in range(childClone.rowCount()): childClone.removeRow(0)
                                               for jc in range(childGroup.rowCount()):
                                                   childClone.insertRow(jc)
                                                   AddLineWidget(child, childClone, jc,  0, 4, 0, float(childGroup.cellWidget(jc, 0).value()))     
                                        elif childGroup.metaObject().className() in ("QComboBox", "MyComboBox") : childClone.setCurrentIndex(childGroup.currentIndex())

            refchild.tabWidget.setCurrentIndex(posIndex)
            child.ComboLayers.setCurrentIndex(refchild.ComboLayers.currentIndex())
            child.PrimaryXSLT.setCurrentIndex(refchild.PrimaryXSLT.currentIndex())
            
            index = self.synchroIconTab(child, True, posIndex)
            self.fixeModeDialog(child.histoIDChangeMode, index)
            child.doChangeMode(idbutton)
            child.changeMode.button(idbutton).setChecked(True)
            child.histoIDChangeMode = idbutton
            
            nameObj = self.listNameActionsTabEdition[posIndex]
            Obj = self.findChild(MyPushButton, nameObj)
            if Obj : Obj.setChecked(True)               
            
            
        def closeCurrentWindow(self):
            dialog, child = self.fixeMDDWindow()
            Id = -1 
            for Id, mdiWindow in self.listSubWindows.items():
                if mdiWindow == dialog :
                   break     
            if child :
               item = getKeyInDicoFromValue(self.listWindowsButtons, Id)
               child.killWindows()
               index = -1
               if item != None :
                       self.mdi.removeSubWindow(dialog)
                       index = self.listWindowsButtons.indexOfTopLevelItem(item)
                       if index > -1 : self.listWindowsButtons.takeTopLevelItem(index)
                       del self.listSubWindows[Id]
               self.majCountersSubWindows()
               self.refreshGroupWindowsButtons()
               dialog, child = self.fixeMDDWindow()
               self.changeStateButtons(child)
               

        def changeViewWindowsButtons(self):
             self.myViewSubWindows.setVisible(not self.myViewSubWindows.isVisible())
             self.changeAspectButtonViewWindowsButtons()

        def changeAspectButtonViewWindowsButtons(self):      
             Obj = self.findChild(MyPushButton, "modeWindow")
             if Obj : Obj.setIcon(QIcon(getThemeIcon("windowmdiarea_%s.png".lower() % self.myViewSubWindows.isVisible())))

            
        #========================
        # BLOC ACTIONS WEB
        #========================                       
        def openLustreWizard(self):
            if self.dialogLUSTRE == None :    
                self.dialogLUSTRE = LusTREDialog(self, "http://linkeddata.ge.imati.cnr.it/", False)
                self.windowsNoMDIChilds.append(self.dialogLUSTRE)
            self.dialogLUSTRE.show()
            self.dialogLUSTRE.activateWindow() 


        #CSW-T BLOC FUNTIONS
        def setEnabledCSWTActions(self):
                zCond = True if (self._connexionCSWT != None and self._connexionCSWT.connected()) else False
                for item in self.listNameActionsTabWebServices :
                    Obj = self.findChild(MyPushButton, item)
                    if Obj :
                       Obj.setEnabled(not zCond) if item == "authCSWTButton" else Obj.setEnabled(zCond)
                       dialog, child = self.fixeMDDWindow()
                       self.changeStateButtons(child)
                       
        def authCSWT(self):
                nameCSWT = getSelConnexion(self)
                mySettings = QSettings()
                serverCSWT = (mySettings.value("/qsphere/connections/%s/host" % (nameCSWT)))
                authServerCSWT = (mySettings.value("/qsphere/connections/%s/authhost" % (nameCSWT)))
                UserCSWT = (mySettings.value("/qsphere/connections/%s/username" % (nameCSWT)))
                pwdUserCSWT = (mySettings.value("/qsphere/connections/%s/password" % (nameCSWT)))

                dialog = AuthCSWTDialog(UserCSWT, pwdUserCSWT, serverCSWT, False)
                MakeWindowIcon(dialog, "connect.png")
                if dialog.exec_():
                   self.startMovie()

                   self._connexionCSWT = cswtConnection(self, nameCSWT, serverCSWT, authServerCSWT)
                   responseCSWT = self._connexionCSWT.initSession(dialog.authInfos()[0], dialog.authInfos()[1], True)

                   if responseCSWT != None :
                           self.setEnabledCSWTActions()

                           Obj = self.findChild(MyPushButton, "authCSWTButton")

                           if Obj :     
                                   if not Obj.isEnabled():
                                      zTitle = QApplication.translate("QSphere", "Information" ) 
                                      zMsg = QApplication.translate("QSphere","Connected with the server")
                                      zPicto = QgsMessageBar.INFO
                                      zDuration = self.duration_info
                                   else :
                                      zTitle = QApplication.translate("QSphere", "Warning" ) 
                                      zMsg = QApplication.translate("QSphere","Error")
                                      zPicto = QgsMessageBar.WARNING
                                      zDuration = self.duration_warning
                          
                                   SendMessage(self, zTitle, "%s" % (zMsg), zPicto, zDuration)
                           
                   if responseCSWT == None : self.getAllReporting()

                   self.stopMovie()


        def disconnectCSWT(self):
                if self._connexionCSWT != None :
                    if self._connexionCSWT.connected() :
                       self._connexionCSWT.closeSession()
                       self._connexionCSWT = None
                       self.setEnabledCSWTActions()
                       
                       Obj = self.findChild(MyPushButton, "authCSWTButton")
                       if Obj :
                               if Obj.isEnabled():
                                  zTitle = QApplication.translate("QSphere", "Information" ) 
                                  zMsg = QApplication.translate("QSphere","Disconnected with the server")
                                  zPicto = QgsMessageBar.INFO
                                  zDuration = self.duration_info
                               else :
                                  zTitle = QApplication.translate("QSphere", "Warning" ) 
                                  zMsg = QApplication.translate("QSphere","Error")
                                  zPicto = QgsMessageBar.WARNING
                                  zDuration = self.duration_warning
                      
                               SendMessage(self, zTitle, "%s" % (zMsg), zPicto, zDuration)   

        def getAllReporting(self):
                if self._connexionCSWT != None : self.getReporting(self._connexionCSWT.allreporting(), False, "editxml.png", True)
        
        def getReporting(self, responseCSWT, isReporting, iconpath, isModal):
                d = xmlEditor(self, "")
                MakeWindowIcon(d, iconpath)
                d.setWindowTitle("%s : %s" % (d.racTitle, ""))
                d.show() if isModal else d.exec_()

                if isReporting :
                    try : charset = (responseCSWT.headers["Content-Type"].split("=")[1].strip())
                    except : charset = "utf-8"  
                    try : d.editor.setText("%s%s" % (self._connexionCSWT.reporting(), responseCSWT.read().decode(charset)))
                    except : d.editor.setText("%s%s" % (self._connexionCSWT.reporting(), responseCSWT))
                else :
                    d.editor.setText(responseCSWT)
                    
                d.checkProperties()
                d.BadMyISO()


        def recordsInCSWT(self): self.actionsInCSWT(6)                
        def insertInCSWT(self): self.actionsInCSWT(1)
        def updateInCSWT(self): self.actionsInCSWT(2)
        def deleteInCSWT(self): self.actionsInCSWT(-1)

        def actionsInCSWT(self, ucase):
                dialog, child = self.fixeMDDWindow()
                if child or ucase == 6 :        
                        self.startMovie()
                        if ucase in (1,2) :
                            if child.windowTitle() != child.racWindowTitle and child.windowTitle().find("~")== -1 :        
                                child.SaveData()
                                fileName = child.windowTitle().replace(child.racWindowTitle, "")
                                extension = GetExtension(fileName)
                                if extension == ".xml" :
                                    f = open(fileName, "r", encoding='utf-8')
                                    dataXML = f.read()
                                    f.close()
                                elif extension == ".qsp" : dataXML = ExportToXML(child, None) .decode("utf-8")
                            else :  dataXML =   ExportToXML(child, None).decode("utf-8") 
  
                            dataXML = convertToUTF8(unquote(dataXML))
                            
                            pos = dataXML.find("<gmd:MD_Metadata")
                            dataXML = dataXML[pos:]
                            
                        elif ucase == -1 :
                            zObj = child.findChild(QLineEdit, "identificator")
                            if zObj : dataXML = zObj.text()
                            else : return
                        elif ucase == 6: dataXML = None    
                        else : return

                        if self._connexionCSWT != None :
                           responseCSWT = self._connexionCSWT.metadata_csw_publication(ucase, dataXML, True) 
                           if ucase != 6 : self._connexionCSWT.analyseResponse(ucase, responseCSWT)

                           if self.reportingCSWT : self.getReporting(responseCSWT, True, "editxml.png", True)

                        self.stopMovie()

        #END BLOC CSWT

        #========================
        # BLOC ACTIONS TOOLS KIT
        #========================
        def openToolSearchFiles(self):
            if self.dialogSearchFiles == None :    
                    self.dialogSearchFiles = toolSearchFilesDialog(self)
                    self.windowsNoMDIChilds.append(self.dialogSearchFiles)
                    MakeWindowIcon(self.dialogSearchFiles, "toolSearchFiles.png")
            self.dialogSearchFiles.show()
            

        def openXMLEditor(self):
                d = xmlEditor(None, "" )
                MakeWindowIcon(d, "editxml.png")
                MakePropertiesForWindow(d, self)
                d.setWindowTitle("%s : %s" % (d.racTitle, ""))
                d.LoadFile()
                d.exec_()

        def openContacts(self):
                d = DialogContacts(self, False)
                d.exec_()

        def openOptions(self):
                d = DialogOptions(self.parent)
                d.exec_()
                

        #===============================
        # BLOC ACTIONS MAINWINDOW ITEMS
        #===============================
        def makeMenuCentralWidget(self, tabTarget, icon, title, listActions, onTab):
                toolBar = QToolBar(tabTarget)
                toolBar.setObjectName(title)
                toolBar.setAllowedAreas(Qt.TopToolBarArea | Qt.BottomToolBarArea)
                toolBar.setWindowTitle(title)
                toolBar.setStyleSheet("QToolBar {spacing:5px;}")
                conteneur = None
	    
                for item in listActions :
                        if item[0]=="-":  toolBar.addSeparator(); conteneur = None;
                        elif item[0]=="~":
                          Obj = QGroupBox()       
                          Obj.setGeometry(item[3][0], item[3][1], item[3][2], item[3][3])
                          Obj.setMinimumSize(item[3][2], item[3][3])
                          Obj.setMaximumSize(item[3][2], item[3][3])
                          Obj.setStyleSheet("QGroupBox { font-size: 12px;  text-align: center; color : black; border: 0px;}"
                                            "QGroupBox::title {top: -2px; left: 10px;}")

                          background = QLabel(Obj)
                          background.setGeometry(10, 10, item[3][2]-20, 26)
                          background.setStyleSheet(" QLabel {background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, stop: 0 #E1E1E1, stop: 0.4 #9B9B9B, stop: 0.5 #D8D8D8, stop: 1.0 #D3D3D3);  border-width: 2px; border-radius: 10px; border-color: beige;}")

                          trumbail = QLabel(Obj)
                          trumbail.setGeometry(0, 10, 90, 25)
                          trumbail.setText("%s :" % QApplication.translate("QSphere",item[1]))
                          trumbail.setObjectName("Label%s_%s" % (item[1], item[2].split(".")[0]))
                          trumbail.setAlignment(Qt.AlignRight)
                          trumbail.setStyleSheet(" QLabel { font-size: 12px; color : black; background-color: rgba(160, 160, 160, 125); border: 0.5px solid black;  border-radius: 4px;  padding: 2px;}")

                          toolBar.addWidget(Obj)
                          conteneur = Obj

                          
                        elif item[0] in ("childsCount", "windowsCount"):
                          Obj = QLabel() if not conteneur else QLabel(conteneur)      
                          Obj.setGeometry(item[3][0], item[3][1], item[3][2], item[3][3])
                          Obj.setObjectName("%s" % item[0])
                          zIcon = QImage(getThemeIcon(item[2])) 
                          Obj.setPixmap(QPixmap.fromImage(zIcon))
                          Obj.setToolTip(QApplication.translate("QSphere",item[1]))

                          if not conteneur : toolBar.addWidget(Obj)

                          font = QFont()
                          font.setFamily('Courier')
                          font.setFixedPitch(True)
                          font.setPointSize(12)
                          font.setBold(True)

                          nbObj = QTextEdit() if not conteneur else QTextEdit(conteneur)
                          nbObj.setGeometry(item[3][0]+item[3][2]+5, item[3][1], item[3][2], item[3][3])
                          nbObj.setMinimumSize(item[3][2], item[3][3])
                          nbObj.setMaximumSize(item[3][2], item[3][3])
                          nbObj.setStyleSheet("QTextEdit { font-size: 14px;  text-align: center; color : white; background-color: rgba(160, 160, 160, 125); border: 2px solid cyan;  border-radius: 4px;  padding: 2px;}")
                          nbObj.setText("0")
                          nbObj.setFont(font)
                          nbObj.setAlignment(Qt.AlignCenter)
                          nbObj.setEnabled(False)
                          
                          if not conteneur : toolBar.addWidget(nbObj)

                          if item[0] == "childsCount" : self.nb_window_childs = nbObj
                          elif item[0] == "windowsCount" : self.nb_subwindows = nbObj                 
                         
                        else:
                          Obj = MyPushButton() if not conteneur else MyPushButton(conteneur)

                          zText = QApplication.translate("QSphere",item[1])
                          if item[0] == "newSession" : zText = "%s%s" % (zText, "Ctrl+Shift+N".rjust(60-len(zText)))
                          if item[0] == "openSession" : zText = "%s%s" % (zText, "Ctrl+Shift+F".rjust(60-len(zText)))
                          if item[0] == "saveSession" : zText = "%s%s" % (zText, "Ctrl+Shift+W".rjust(60-len(zText)))
                          if item[0] == "newFile" : zText = "%s%s" % (zText, "Ctrl+N".rjust(60-len(zText)))
                          if item[0] == "openFile" : zText = "%s%s" % (zText, "Ctrl+F".rjust(60-len(zText)))
                          if item[0] == "saveFile" : zText = "%s%s" % (zText, "Ctrl+S".rjust(60-len(zText)))
                          if item[0] == "saveAll" : zText = "%s%s" % (zText, "Ctrl+A".rjust(60-len(zText)))
                         
                          Obj.initPushButton(item[3][2], item[3][3], item[3][0], item[3][1], item[0], "", zText, True, getThemeIcon(item[2]), item[3][2], item[3][3], True)
                          if item[4]!= None : Obj.clicked.connect(item[4]) if type(item[4])!=str else eval(item[4])
                          if item[5]!="" : Obj.setShortcut(QKeySequence(item[5]))
                          Obj.setEnabled(item[6])

                          if item[0] =="openSession" : self.butopensession = Obj
                          elif item[0] =="openFile" : self.butopenfile = Obj
                          elif item[0] == "saveSession" : self.butsavesession = Obj
                          elif item[0] == "navigatorWeb" : self.butnavigatorweb = Obj
           
                          if item[0] in self.listNameActionsTabEdition:
                                Obj.setCheckable(True)
                                Obj.setStyleSheet(self.styleSheetPushButton)
                                if item[0] == "identificationTab" : Obj.setChecked(True)
                                self.positionTab.addButton(Obj, self.listNameActionsTabEdition.index(item[0]))

                          if item[0] in ("formMode", "xmlMode", "htmlMode"):
                                Obj.setCheckable(True)
                                Obj.setStyleSheet(self.styleSheetPushButton)
                                if item[0] == "formMode" : Obj.setChecked(True)
                                self.changeMode.addButton(Obj, ("formMode", "xmlMode", "htmlMode").index(item[0]))

                          if not conteneur : toolBar.addWidget(Obj)
                
                i = len(listActions)-1
                item = listActions[i]

                toolBar.setGeometry(0, 0, i*65, item[3][3]+20)   
                if onTab : self.tabWidget.addTab(tabTarget, QIcon(getThemeIcon(icon)), QApplication.translate("QSphere",title))

                return toolBar

                
        def startMovie(self):
            self.status_txt.setVisible(True)
            self.movie.start()
            self.status_txt.repaint()

        def stopMovie(self):
            self.movie.stop()
            self.status_txt.setVisible(False)

            
        def resizeEvent(self,ev):
            zSize = ev.size()
            self.tabWidget.setGeometry(0, 0, self.width(), 100)
            self.tabWidget.setStyleSheet(
            "QTabWidget::pane {height: 100px;border-top: 2px solid #C2C7CB; position: absolute; top: -0.5em; background-color: cyan;}" 
            "QTabWidget::tab-bar {alignment: center; }" 
            "QTabBar::tab:selected { border-color: #5D5D5D; border-bottom-color: #C2C7CB; border-bottom: 0px solid #C2C7CB; background-color: #f0f0f0;}"
            "QTabBar::tab {height: 64px; width: %spx; background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, stop: 0 #E1E1E1, stop: 0.4 #9B9B9B, stop: 0.5 #D8D8D8, stop: 1.0 #D3D3D3); border: 2px solid #C4C4C3; border-bottom-color: #C2C7CB; border-top-left-radius: 4px; border-top-right-radius: 4px; min-width: 8ex; padding: 2px;}" % (ceil(self.width()/self.tabWidget.count())-11)
            )
            self.blocProgressBar.setGeometry((self.width()/2)-205, (self.height()/2)-120, 400, 230)
            self.status_txt.setGeometry((self.width()/2)-64, (self.height()/2)-64, 64, 64)
            self.barInfo.setGeometry(0, 0, self.width(), 90)
            

        def closeEvent(self,event):
                MyMsgBoxDialog = myMsgBoxDialog(self, QApplication.translate("QSphere","Confirm Exit..."),
                                                QApplication.translate("QSphere","Are you sure you want to exit ?"), "qsphere_stop.png")
                ret = MyMsgBoxDialog.exec_()
                if ret == 1 :
                   self.saveInfos("sessions", self.listSessions)
                   self.saveInfos("fileshistory", self.listMDDFiles)
                   self.parent.mainWindow = None
                   if self.dialogLUSTRE : self.dialogLUSTRE.close()
                   if self.dialogSGBDR : self.parent.dialogSGBDR = None; self.dialogSGBDR.close()
                   try : self.myViewSubWindows.close() 
                   except : pass  
                   event.accept()
                else : event.ignore()
                        

                   
        def contextMnuSaveSessionActions(self, Obj):
                contextMnu_SaveSessionActions = QMenu()

                menuIcon = getThemeIcon("saveas.png")
                zText = QApplication.translate("QSphere","Save session as")
                self.SaveSessionAsButton = QAction(QIcon(menuIcon), "%s ..." % zText, self)
                self.SaveSessionAsButton.setObjectName("SaveAsButton")
                contextMnu_SaveSessionActions.addAction(self.SaveSessionAsButton)
                self.SaveSessionAsButton.triggered.connect(self.saveSession)

                contextMnu_SaveSessionActions.addSeparator()

                menuIcon = getThemeIcon("savecopy.png")
                zText = QApplication.translate("QSphere","Save as a copy ...")
                self.SaveSessionCopyAsButton = QAction(QIcon(menuIcon), zText, self)
                self.SaveSessionCopyAsButton.setObjectName("SaveCopyAsButton")
                contextMnu_SaveSessionActions.addAction(self.SaveSessionCopyAsButton)
                self.SaveSessionCopyAsButton.triggered.connect(self.saveSession)

                Obj.setMenu(contextMnu_SaveSessionActions)


        def contextMnuSaveActions(self, Obj):
                contextMnu_SaveActions = QMenu()

                menuIcon = getThemeIcon("saveas.png")
                zText = QApplication.translate("QSphere","Save as ...")
                self.SaveAsButton = QAction(QIcon(menuIcon), zText, self)
                self.SaveAsButton.setObjectName("SaveAsButton")
                self.SaveAsButton.setShortcut(QKeySequence("Ctrl+Shift+S"))
                contextMnu_SaveActions.addAction(self.SaveAsButton)
                self.SaveAsButton.triggered.connect(self.saveAsMetadataFile)


                #TEST 4.3
                menuIcon = getThemeIcon("layers-database.png")
                zText = "%s ..." % QApplication.translate("QSphere","Save in database")
                self.SaveInDataBase = QAction(QIcon(menuIcon), zText, self)
                self.SaveInDataBase.setObjectName("SaveInDataBase")
                self.SaveInDataBase.setShortcut(QKeySequence("Ctrl+Shift+D"))
                contextMnu_SaveActions.addAction(self.SaveInDataBase)
                self.SaveInDataBase.triggered.connect(self.saveMetadataInBase)                

                

                contextMnu_SaveActions.addSeparator()

                menuIcon = getThemeIcon("savecopy.png")
                zText = QApplication.translate("QSphere","Save as a copy ...")
                self.SaveCopyAsButton = QAction(QIcon(menuIcon), zText, self)
                self.SaveCopyAsButton.setObjectName("SaveCopyAsButton")
                self.SaveCopyAsButton.setShortcut(QKeySequence("Ctrl+Shift+C"))
                contextMnu_SaveActions.addAction(self.SaveCopyAsButton)
                self.SaveCopyAsButton.triggered.connect(self.saveAsMetadataFile)

                contextMnu_SaveActions.addSeparator()

                menuIcon = getThemeIcon("saveattribut.png")
                zText = QApplication.translate("QSphere","Save as the Fields Map ...")
                self.SaveXmlCatButton = QAction(QIcon(menuIcon), zText, self)
                self.SaveXmlCatButton.setObjectName("SaveXmlCatButton")
                contextMnu_SaveActions.addAction(self.SaveXmlCatButton)
                self.SaveXmlCatButton.triggered.connect(self.saveXmlCatFile)

                Obj.setMenu(contextMnu_SaveActions)

        def fixeMaxDim(self, listItems):
                maxDim = 60
                if listItems != []:
                   for item in listItems: maxDim = max(maxDim,len(item))
                maxDim = int(maxDim * 1.8)
                return maxDim

        #TEST 4.3 - TO PLACE IN UTILS
        def makeTextForMenu(self, pattern, text, maxDim, shorcuts):
                return pattern % (text.ljust(maxDim-len(text)), shorcuts)
                
        def buildContextMnuFile(self, Obj):
                self.contextMnuFile = QMenu()

                maxDim, pattern = self.fixeMaxDim(self.listMDDFiles), "%s ... %s"

                menuIcon = getThemeIcon("openmeta.png")
                zText = self.makeTextForMenu(pattern, QApplication.translate("QSphere","Load a metadata file"), maxDim, "Ctrl+F")
                self.openFile = QAction(QIcon(menuIcon), zText, self)
                self.openFile.setObjectName("mActionOpenFile")
                self.contextMnuFile.addAction(self.openFile)
                self.openFile.triggered.connect(self.openMetadataFile)

                #TEST 4.3
                self.contextMnuFile.addSeparator()

                menuIcon = getThemeIcon("layers-icon.png")
                zText = self.makeTextForMenu(pattern, QApplication.translate("QSphere","Load metadata file for layers"), maxDim, "Ctrl+L")
                self.openFromLayers = QAction(QIcon(menuIcon), zText, self)
                self.openFromLayers.setObjectName("mActionOpenFromLayers")
                self.contextMnuFile.addAction(self.openFromLayers)
                self.openFromLayers.triggered.connect(self.openMetadataFileForLayers)

                menuIcon = getThemeIcon("layers-database.png")
                zText = self.makeTextForMenu(pattern, QApplication.translate("QSphere","Load metadata file from database"), maxDim, "Ctrl+D")
                self.openFromDataBase = QAction(QIcon(menuIcon), zText, self)
                self.openFromDataBase.setObjectName("mActionOpenFromDataBase")
                self.contextMnuFile.addAction(self.openFromDataBase)
                self.openFromDataBase.triggered.connect(self.openMetadataFromBase)                

                
                menuIcon = getThemeIcon("openmeta.png")
                
                if self.listMDDFiles != []:
                        self.contextMnuFile.addSeparator()

                        i = 0
                        for mddfile in self.listMDDFiles :
                            if mddfile :    
                                    self.actionLastFile = QAction(QIcon(menuIcon), mddfile, self)
                                    self.actionLastFile.setObjectName("actionLastFile%s" % (i) )
                                    self.contextMnuFile.addAction(self.actionLastFile)
                                    self.actionLastFile.triggered.connect(self.openLastFile)
                                    i+= 1


                self.contextMnuFile.addSeparator()

                menuIcon = getThemeIcon("poubelle.png")
                zText = "%s ..." % QApplication.translate("QSphere","Clear history")
                self.delAllSavedFiles = QAction(QIcon(menuIcon), zText, self)
                self.delAllSavedFiles.setObjectName("delAllSavedFiles")
                self.contextMnuFile.addAction(self.delAllSavedFiles)
                self.delAllSavedFiles.triggered.connect(self.delInfos)

                Obj.setMenu(self.contextMnuFile)
                

        def buildContextMnuSession(self, Obj):
                self.contextMnuSession = QMenu()

                menuIcon = getThemeIcon("opensession.png")
                zText = "%s ..." % QApplication.translate("QSphere","Open session")

                maxDim = self.fixeMaxDim(self.listSessions)
                
                zText = "%s%s" % (zText, "Ctrl+Shift+F".rjust(maxDim-len(zText)))
                self.OpenSession = QAction(QIcon(menuIcon), zText, self)
                self.OpenSession.setObjectName("mActionOpenSession")
                self.contextMnuSession.addAction(self.OpenSession)
                self.OpenSession.triggered.connect(self.openSession)
                
                if self.listSessions != []:
                        self.contextMnuSession.addSeparator()

                        i = 0
                        for session in self.listSessions :
                            if session :    
                                    self.actionLastSession = QAction(QIcon(menuIcon), session, self)
                                    self.actionLastSession.setObjectName("actionLastSession%s" % (i) )
                                    self.contextMnuSession.addAction(self.actionLastSession)
                                    self.actionLastSession.triggered.connect(self.openLastSession)
                                    i+= 1

                self.contextMnuSession.addSeparator()

                menuIcon = getThemeIcon("poubelle.png")
                zText = "%s ..." % QApplication.translate("QSphere","Clear history")
                self.delAllSavedSession = QAction(QIcon(menuIcon), zText, self)
                self.delAllSavedSession.setObjectName("delAllSavedSession")
                self.contextMnuSession.addAction(self.delAllSavedSession)
                self.delAllSavedSession.triggered.connect(self.delInfos)

                Obj.setMenu(self.contextMnuSession)


        def buildContextMnuNavigatorWeb(self, Obj):
                self.contextMnuNavigatorWeb = QMenu()

                menuIcon = getThemeIcon("navigatorweb.png")
                zText = QApplication.translate("QSphere","Web navigator ...")
                self.OpenNavigatorWeb = QAction(QIcon(menuIcon), zText, self)
                self.OpenNavigatorWeb.setObjectName("mActionNavigator")
                self.contextMnuNavigatorWeb.addAction(self.OpenNavigatorWeb)
                self.OpenNavigatorWeb.triggered.connect(self.DownloadMetadata)

                self.contextMnuNavigatorWeb.addSeparator()

                menuIcon = getThemeIcon("dmetadata.png")
                zText = QApplication.translate("QSphere","Url Server for metadata : ")
                self.contextMnu_serverMetadata = QMenu(zText)
                self.contextMnu_serverMetadata.setIcon(QIcon(menuIcon))
                i = 0
                for elt in self.serverMetadata :
                    self.OpenServerMDD = QAction(QIcon(menuIcon), elt, self)
                    self.OpenServerMDD.setObjectName("OpenServerMDD%s" % (i) )
                    self.contextMnu_serverMetadata.addAction(self.OpenServerMDD)
                    self.OpenServerMDD.triggered.connect(self.DownloadMetadata)
                    i+= 1

                self.contextMnuNavigatorWeb.addMenu(self.contextMnu_serverMetadata)
                self.contextMnuNavigatorWeb.addSeparator()

                menuIcon = getThemeIcon("dkeywords.png")
                zText = QApplication.translate("QSphere","Url Server for keywords : ")
                self.contextMnu_serverKeywords = QMenu(zText)
                self.contextMnu_serverKeywords.setIcon(QIcon(menuIcon))
                i = 0
                for elt in self.serverKeywords :
                    self.OpenServerKW = QAction(QIcon(menuIcon), elt, self)
                    self.OpenServerKW.setObjectName("OpenServerKW%s" % (i) )
                    self.contextMnu_serverKeywords.addAction(self.OpenServerKW)
                    self.OpenServerKW.triggered.connect(self.DownloadMetadata)
                    i+= 1

                self.contextMnuNavigatorWeb.addMenu(self.contextMnu_serverKeywords)

                self.contextMnuNavigatorWeb.addSeparator()
                
                menuIcon = getThemeIcon("info.png")
                zText = QApplication.translate("QSphere","Get informations about metadata and INSPIRE")
                self.helptopic = QAction(QIcon(menuIcon), zText, self)
                self.helptopic.setObjectName("helptopic")
                self.contextMnuNavigatorWeb.addAction(self.helptopic)
                self.helptopic.triggered.connect(self.openHelpINSPIRE)
                
                Obj.setMenu(self.contextMnuNavigatorWeb)

        #LOAD AND SAVE HISTORY FOR FILES OR SESSIONS
        def ajustListInfos(self, historyFile, listinfos):
            if historyFile in listinfos : return    
            newHistory = []
            newHistory.append(historyFile)
            for i in range(min(len(listinfos), 9)) :
                if listinfos[i] != "" : newHistory.append(listinfos[i])
            if listinfos is self.listSessions :
               self.listSessions = list(newHistory)
               self.buildContextMnuSession(self.butopensession)
            elif listinfos is self.listMDDFiles :
               self.listMDDFiles = list(newHistory)
               self.buildContextMnuFile(self.butopenfile)
                
        def saveInfos(self, flaginfo, listinfos):
            mySettings = QSettings()
            pos = 0
            self.delSavedInfos(flaginfo, listinfos, False)
            for i in range(min(len(listinfos), 10)) : 
                historyFile = listinfos[i]
                if historyFile :
                   mySettings.setValue("/qsphere/%s/" % flaginfo, pos)
                   mySettings.setValue("/qsphere/%s/%s/file" % (flaginfo, pos), "%s" % historyFile)
                   pos+= 1
            mySettings.sync()   

        def loadInfos(self, flaginfo, listinfos):
            mySettings = QSettings()
            mySettings.beginGroup("/qsphere/%s/" % flaginfo)
            keys = mySettings.childGroups()
            if keys != []:
                   valueSettings = QSettings() 
                   for key in keys :
                       historyFile = valueSettings.value("/qsphere/%s/%s/file" % (flaginfo, key))
                       if historyFile : listinfos.append(historyFile)

        def delInfos(self):
            if self.sender().objectName()== "delAllSavedSession" : self.delSavedInfos("sessions", self.listSessions, True)
            elif self.sender().objectName()== "delAllSavedFiles" : self.delSavedInfos("fileshistory", self.listMDDFiles, True)
            
        def delSavedInfos(self, flaginfo, listinfos, askFor):
                if askFor :
                        MyMsgBoxDialog = myMsgBoxDialog(self, QApplication.translate("QSphere","Warning"),
                                QApplication.translate("QSphere", "Delete all the entries ?"), "qsphere_stop.png")
                        ret = MyMsgBoxDialog.exec_()
                        if ret !=  1 : return
                    
                mySettings = QSettings()
                mySettings.beginGroup("/qsphere/%s/" % flaginfo)
                keys = mySettings.childGroups()
                myValueSettings = QSettings()
                if keys != []:
                  for key in keys : myValueSettings.remove("/qsphere/%s/%s" % (flaginfo, key))
                myValueSettings.sync()

                if askFor :   
                        if listinfos is self.listSessions :
                          self.listSessions = []
                          self.buildContextMnuSession(self.butopensession)
                        elif listinfos is self.listMDDFiles :
                          self.listMDDFiles = []     
                          self.buildContextMnuFile(self.butopenfile)

               
            
